// Leagcy Quadrature reader
/* A project that that will read and decode 4 or 5 quadrature inputs
 from a Legacy Ornamental Mill.
 Written by Brian C. Slater, starting on May 7, 2005
*/

/*	This section is where the various counts from the Quad readers are
	scaled, sent to the BCD converter
	and then added to hex 30 to create ta-da! ASCII code for the numbers
	which is then sent to the LCD module to be displayed
*/

/*	I wrote this section all by myself, alone, so it's got the worst code
	If you can see a better (in ANY way) method, please email me or post it at the FPGAS4fun.com forum
*/

module Display_Legacy(CLK_0,// LED,
	 Count_X, Count_Y,
	 Count_Z, Count_A,
	 Reset_NOT,
	 LCD_0, LCD_1, LCD_2, LCD_3, LCD_4, LCD_5, LCD_6, LCD_7, LCD_RS, LCD_E, LCD_RW
	 );

parameter BITS_IN_PP         = 16; // # of bits of binary input
parameter BCD_DIGITS_OUT_PP  = 5;  // # of digits of BCD output
parameter BIT_COUNT_WIDTH_PP = 4;  // Width of bit counter
parameter LCD_Pos = 0;
parameter Last_Channel =4;

// These are the multipliers to convert the quad reader counts to hundredths of an inch
// Currently, the only axis that I have an encoder for is the "X" axis,
// (anybody know here I can get a Unimeasure LX-EP with an encoder, CHEAP?)
// eventually the Factor numbers will reflect the different encoders counts per inch/degree
// These are really in binary/hex (65536 = 10000 in hex), this saves gobs and gobs of space over decimal
// in fact, when I was using decimal, there was barely enough room for 3 channels let alone 4!
parameter X_Factor	= 83614;
parameter X_Multi	= 65536;
parameter Y_Factor	= 83614;
parameter Y_Multi	= 65536;
parameter Y_Zero	= 40663;
parameter Z_Factor	= 83614;
parameter Z_Multi	= 65536;
parameter A_Factor	= 83614;
parameter A_Multi	= 65536;

input CLK_0;
input Reset_NOT;// This shows up here as a way to clear the LCD on command

input [BITS_IN_PP-1:0]Count_X;
input [BITS_IN_PP-1:0]Count_Y;
input [BITS_IN_PP-1:0]Count_Z;
input [BITS_IN_PP-1:0]Count_A;

output LCD_0, LCD_1, LCD_2, LCD_3, LCD_4, LCD_5, LCD_6, LCD_7, LCD_RS, LCD_E, LCD_RW;

reg CLK_2;
reg [8:0] writedata;// yes, Virgina, I know it's only an 8 bit bus, this includes LCD_RS
reg start_i;							// initiates a conversion
reg [BITS_IN_PP-1:0] dat_binary_i;		// binary input bus
reg [4*BCD_DIGITS_OUT_PP-1:0] dat_bcd_o;// BCD output bus

reg [6:0] Text_Counter;// This cycles through the sections sent to the LCD and the numbers, too
reg Decimal_Pos;
reg Signed;
wire LCD_RW;// your grounded!
 
//LCD display wires
assign LCD_0 = writedata[0];
assign LCD_1 = writedata[1];
assign LCD_2 = writedata[2];
assign LCD_3 = writedata[3];
assign LCD_4 = writedata[4];
assign LCD_5 = writedata[5];
assign LCD_6 = writedata[6];
assign LCD_7 = writedata[7];
assign LCD_RS = writedata[8];
assign LCD_RW = 0;
// LCD initiate data transfer
assign LCD_E = (CLK_2 & (Text_Counter[6:4] <= Last_Channel) & (Text_Counter[3:0] <= 8));

// binary counts to BCD converter
BCD_Legacy BCD_Legacy_A(.CLK_0(CLK_0), .dat_binary_i(dat_binary_i), .dat_bcd_o(dat_bcd_o), .start_i(start_i));

// This section sends the individual characters to the LCD
// The display is: axis, sign, and 5 digits of numerials with a decimal point

// yes, I know case statements would have been good here for the different sections,
//	(initalize and the four axes)
//  (hey, that sounds like a rock group!)
//  (sorry, couldn't resist)
//  (NO, I'm not making a printed circuit board, it's a FPGA, don't need no stinkin` resist!)
//  (Yeah, I know, I'm bad, (small, quiet) whimper) (snigger, snigger)
// but I haven't figured out how work them yet, I'm not sure why, I've used case statments in "C" and VB
// writedata[8] is the LCD_RS bit and is set here - note the zero in "writedata <= 9'h038"

reg [6:0] Text_Counter;
always @ (posedge CLK_2)
begin
	Text_Counter <= Text_Counter + 1;
	if (Text_Counter[3:0] == 2) start_i <= 0;
// initalize LCD, Section 0
	if  (Text_Counter < 5)
	begin
	 	if (Text_Counter[3:0] == 0) writedata <= 9'h038; //  8 bit, two lines, 5X7.  why is it thinking 2 lines instead of four?  Are these people on drugs?
		if (Text_Counter[3:0] == 1)
		begin
			writedata <= 9'h00C;// Display = on, Cursor = off, Cursor blink = off
			Text_Counter <= 15;// This speeds up the display as there aren't any counts to display here
		end
	end
	else
// Now for real data, first the postition, then the axis name, then the sign, then the number with decimal point
	begin
//	writedata <= 9'h120;
	// first axis is X, Section 1
		if  (Text_Counter[6:4] == 1)
		begin
			if (Text_Counter[3:0] == 0) writedata <= 9'h080; // Position at left edge, first line
			if (Text_Counter[3:0] == 1)
			begin
				dat_binary_i <= (Count_X * X_Factor)/X_Multi;//this scales the X axis data and moves it to the BCD converter
				start_i <= 1;// Start the BCD converter
				writedata <= 9'h158;// move "X" to the LCD
				Decimal_Pos <= 0;
			end
		end

	// Second axis is Y, Section 2
	// this is the only section that actually needs the +/- sign
	// also, it needs to have the minus side converted from binary neg to pos 
		if  (Text_Counter[6:4] == 2)
		begin	
			if (Text_Counter[3:0] == 0) writedata <= 9'h0C0; // Position at left edge, second line
			if (Text_Counter[3:0] == 1)
			begin
				if (Count_Y[BITS_IN_PP-1])
				begin
				// need to set this for negatives
					Signed <= 1;
					//convert from neg to pos
					dat_binary_i <= (((Count_Y ^ 65535)* Y_Factor) / Y_Multi);
				end
				else
					dat_binary_i <= ((Count_Y * Y_Factor) / Y_Multi);
				start_i <= 1;// Start the BCD converter
				writedata <= 9'h159; // move "Y" to the LCD
				Decimal_Pos <= 0;
			end
		end

	// Third axis is Z, Section 3
		if  (Text_Counter[6:4] == 3)
		begin
			if (Text_Counter[3:0] == 0) writedata <= 9'h094; //Position at left edge, third line
			Signed<=0;
			if (Text_Counter[3:0] == 1)
			begin
				dat_binary_i <= (Count_Z * Z_Factor)/Z_Multi;//this scales the Z axis data and moves it to the BCD converter
				start_i <= 1;// Start the BCD converter
				writedata <= 9'h15A; // move "Z" to the LCD
				Decimal_Pos <= 0;
			end
		end
		
	// Fourth axiz is A, Section 4
	// here the decimal point is shifted because this is 360 degrees instead of (max for my system) 49 inches
	// the decimal position is set in the Text_Counter[3:0] == 5 and 6 sections
		if  (Text_Counter[6:4]  == 4)
		begin
			if (Text_Counter[3:0] == 0) writedata <= 9'h0D4;	// Position at left edge, fourth line
			if (Text_Counter[3:0] == 1)
			begin
				dat_binary_i <= (Count_A * A_Factor)/A_Multi;//this scales the A axis data and moves it to the BCD converter
				start_i <= 1;// Start the BCD converter
				writedata <= 9'h141;// move "A" to the LCD
				Decimal_Pos <= 1;
			end
		end	
		
		if (Text_Counter[6:4] > 0 & Text_Counter[6:4] < Last_Channel + 1)
		begin
			if (Text_Counter[3:0] == 2)	writedata <= 9'h12b + (Signed *2);// plus/minus
			/*	Yeah, I know I said "added with hex 30", - I lied -
				 the 1XX gives the LCD_RS signal in all of the codes sent to the LCD module
			*/
			/* try this it should work for all numbers
			 writedata <= 9'h130 + dat_bcd_o[(4*(BCD_DIGITS_OUT_PP-(Text_Counter[3:0]-3)))-1:(4*(BCD_DIGITS_OUT_PP - (Text_Counter[3:0]-2)))];
			 yeah, but then how do I do the decimal points?
			*/
			if (Text_Counter[3:0] == 3) writedata <= 9'h130 + dat_bcd_o[(4*(BCD_DIGITS_OUT_PP-0))-1:(4*(BCD_DIGITS_OUT_PP - 1))];
			if (Text_Counter[3:0] == 4) writedata <= 9'h130 + dat_bcd_o[(4*(BCD_DIGITS_OUT_PP-1))-1:(4*(BCD_DIGITS_OUT_PP - 2))];
			if (Text_Counter[3:0] == 5)
			//this where the decimal Point gets inserted, depending on the digits in the whole number
			begin
				if (!Decimal_Pos)
					writedata <= 9'h12e;// decimal point for 2 digit whole numbers (linear)
				else
					writedata <= 9'h130 + dat_bcd_o[(4*(BCD_DIGITS_OUT_PP-2))-1:(4*(BCD_DIGITS_OUT_PP - 3))];
			end
			if (Text_Counter[3:0] == 6)
			begin
				if (Decimal_Pos)
					writedata <= 9'h12e;// decimal point for 3 digit whole numbers (rotary)
				else
					writedata <= 9'h130 + dat_bcd_o[(4*(BCD_DIGITS_OUT_PP-2))-1:(4*(BCD_DIGITS_OUT_PP - 3))];
			end
			if (Text_Counter[3:0] == 7) writedata <= 9'h130 + dat_bcd_o[(4*(BCD_DIGITS_OUT_PP-3))-1:(4*(BCD_DIGITS_OUT_PP - 4))];
			if (Text_Counter[3:0] == 8)
			begin
				if (!Reset_NOT) // this is where the LCD gets cleared on command
					writedata <= 9'h001;
				else
					writedata <= 9'h130 + dat_bcd_o[(4*(BCD_DIGITS_OUT_PP-4))-1:(4*(BCD_DIGITS_OUT_PP - 5))];
				Text_Counter[3:0] <= 15;// Reset the counter for faster updates
				if (Text_Counter[6:4] == Last_Channel) Text_Counter[6:4]<= 7;
			end//if (Text_Counter[3:0] == 8)
		end//if (Text_Counter[6:4] > 0 & Text_Counter[6:4] < Last_Channel + 1)
	end //	if  (Text_Counter < 4) else
end // always @ (posedge CLK_2)

reg [15:0] counter;
wire CLKi;
assign CLKi = CLK_0;

always @ (posedge CLKi)
begin
	counter = counter + 1;
	if (counter == 0) CLK_2 = ~CLK_2;
end

endmodule
